<?php

namespace XF2SEO\SEOPackage;

use XF\Mvc\Entity\Entity;
use XF2SEO\SEOPackage\Entity\Metadata;

class Callback
{
    public static function renderMetadata(string $nah, array $params): ?string
    {
        $params = array_replace([
            'title' => null,
            'description' => null,
            'type' => null,
            'shareUrl' => null,
            'canonicalUrl' => null,
            'imageUrl' => null,
            'twitterCard' => 'summary',

            'entity' => null,
        ], $params);

        $entity = $params['entity'];
        unset($params['entity']);

        if (!$entity instanceof Entity) {
            throw new \LogicException('Invalid entity');
        }

        /** @var Metadata|null $metadata */
        $metadata = $entity->getRelation(App::RELATION_METADATA);
        if ($metadata === null) {
            return null;
        }

        $title = $metadata->metadata['title'] ?? '';
        $description = $metadata->metadata['description'] ?? '';

        if ($title !== '') {
            $params['title'] = $title;
        }
        if ($description !== '') {
            $params['description'] = $description;
        }

        if ($params['title'] === null && $params['description'] === null) {
            return null;
        }

        return \XF::app()->templater()->renderMacro('metadata_macros', 'metadata', $params);
    }
}
